Summary:	API for Run-time Code Generation
Summary(pl.UTF-8):	API do generowania kodu w czasie działania
Name:		dyninst
Version:	12.0.1
Release:	1
License:	LGPL v2.1+
Group:		Libraries
#Source0Download: https://github.com/dyninst/dyninst/releases
Source0:	https://github.com/dyninst/dyninst/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	a64cd16ed2c364e892fd46b243414833
Patch0:		%{name}-libname.patch
Patch1:		%{name}-x32.patch
Patch2:		%{name}-tbb.patch
URL:		https://dyninst.org/dyninst
# libiberty
BuildRequires:	binutils-devel
BuildRequires:	boost-devel >= 1.61.0
BuildRequires:	cmake >= 3.4.0
BuildRequires:	elfutils-devel >= 0.186
BuildRequires:	flex
BuildRequires:	libgomp-devel
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	rpmbuild(macros) >= 1.605
BuildRequires:	sed >= 4.0
BuildRequires:	tbb-devel >= 2021.4
BuildRequires:	texlive-format-pdflatex
Requires:	elfutils >= 0.186
Requires:	tbb >= 2021.4
ExclusiveArch:	%{ix86} %{x8664} x32 aarch64 ppc ppc64 aarch64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		skip_post_check_so	 libparseAPI\.so.*

%description
Dyninst is an Application Program Interface (API) to permit the
insertion of code into a running program. The API also permits
changing or removing subroutine calls from the application program.
Run-time code changes are useful to support a variety of applications
including debugging, performance monitoring, and to support composing
applications out of existing packages. The goal of this API is to
provide a machine independent interface to permit the creation of
tools and applications that use run-time code patching.

%description -l pl.UTF-8
Dyninst to API (interfejs programowy) pozwalający na wstawianie kodu
do działającego programu. API pozwala także na zmianę lub usuwanie
wywołań funkcji z programu aplikacji. Zmiany kodu w czasie działania
są przydatne w wielu zastosowaniach, w tym diagnostyce, monitorowaniu
wydajności oraz wsparciu składania aplikacji z istniejących pakietów.
Celem tego API jest zapewnienie niezależnego od maszyny interfejsu
pozwalającego na tworzenie narzędzi i aplikacji wykorzystujących
modyfikowanie kodu w czasie działania.

%package devel
Summary:	Header files for dyninst libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek dyninst
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel >= 6:4.7

%description devel
Header files for dyninst libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek dyninst.

%package static
Summary:	Static dyninst libraries
Summary(pl.UTF-8):	Statyczne biblioteki dyninst
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static dyninst libraries.

%description static -l pl.UTF-8
Statyczne biblioteki dyninst.

%package doc
Summary:	Documentation for dyninst libraries
Summary(pl.UTF-8):	Dokumentacja do bibliotek dyninst
Group:		Documentation

%description doc
Documentation for dyninst libraries.

%description doc -l pl.UTF-8
Dokumentacja do bibliotek dyninst.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
export CXXFLAGS="%{rpmcxxflags} -DTBB_DEFINE_STD_HASH_SPECIALIZATIONS"
%cmake . \
	-DINSTALL_CMAKE_DIR:PATH=%{_libdir}/cmake/Dyninst \
	-DINSTALL_DOC_DIR:PATH=%{_docdir}/dyninst \
	-DINSTALL_INCLUDE_DIR:PATH=%{_includedir}/dyninst \
	-DINSTALL_LIB_DIR:PATH=%{_libdir} \

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYRIGHT CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/parseThat
%attr(755,root,root) %{_libdir}/libdynC_API.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynC_API.so.12.0
%attr(755,root,root) %{_libdir}/libdynDwarf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynDwarf.so.12.0
%attr(755,root,root) %{_libdir}/libdynElf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynElf.so.12.0
%attr(755,root,root) %{_libdir}/libdyncommon.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyncommon.so.12.0
%attr(755,root,root) %{_libdir}/libdyninstAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyninstAPI.so.12.0
%attr(755,root,root) %{_libdir}/libdyninstAPI_RT.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyninstAPI_RT.so.12.0
%attr(755,root,root) %{_libdir}/libinstructionAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libinstructionAPI.so.12.0
%attr(755,root,root) %{_libdir}/libparseAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libparseAPI.so.12.0
%attr(755,root,root) %{_libdir}/libpatchAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpatchAPI.so.12.0
%attr(755,root,root) %{_libdir}/libpcontrol.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpcontrol.so.12.0
%attr(755,root,root) %{_libdir}/libstackwalk.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libstackwalk.so.12.0
%attr(755,root,root) %{_libdir}/libsymLite.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libsymLite.so.12.0
%attr(755,root,root) %{_libdir}/libsymtabAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libsymtabAPI.so.12.0

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdynC_API.so
%attr(755,root,root) %{_libdir}/libdynDwarf.so
%attr(755,root,root) %{_libdir}/libdynElf.so
%attr(755,root,root) %{_libdir}/libdyncommon.so
%attr(755,root,root) %{_libdir}/libdyninstAPI.so
%attr(755,root,root) %{_libdir}/libdyninstAPI_RT.so
%attr(755,root,root) %{_libdir}/libinstructionAPI.so
%attr(755,root,root) %{_libdir}/libparseAPI.so
%attr(755,root,root) %{_libdir}/libpatchAPI.so
%attr(755,root,root) %{_libdir}/libpcontrol.so
%attr(755,root,root) %{_libdir}/libstackwalk.so
%attr(755,root,root) %{_libdir}/libsymLite.so
%attr(755,root,root) %{_libdir}/libsymtabAPI.so
%{_includedir}/dyninst
%{_libdir}/cmake/Dyninst

%files static
%defattr(644,root,root,755)
%{_libdir}/libdyninstAPI_RT.a

%files doc
%defattr(644,root,root,755)
%{_docdir}/dyninst
%changelog
* Mon Dec 20 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dyninst.git;a=log;h=master

* Mon Dec 20 2021 Jan Palus <atler@pld-linux.org> fe4c339
- fix build with tbb 2021.4 and finish upgrade

* Thu Dec 16 2021 Jan Palus <atler@pld-linux.org> e051102
- start upgrade to 12.0.1

* Mon Aug 09 2021 Jan Palus <atler@pld-linux.org> e41b099
- boost rebuild

* Tue Jul 28 2020 Jakub Bogusz <qboosh@pld-linux.org> 7a3cf7b
- release 5 (boost 1.73)

* Sun May 03 2020 Jakub Bogusz <qboosh@pld-linux.org> 6c5c961
- updated URL

* Mon Dec 02 2019 Jakub Bogusz <qboosh@pld-linux.org> 4273f5a
- updated dependencies

* Thu Oct 24 2019 Jan Rękorajski <baggins@pld-linux.org> a37f299
- use gcc defines to figure out arch
- rel 4

* Thu Oct 24 2019 Jan Rękorajski <baggins@pld-linux.org> 49d420e
- fix format types that break systemtap build on ix86 and x32
- rel 3

* Mon Oct 07 2019 Jan Rękorajski <baggins@pld-linux.org> efd5770
- rebuild with boost 1.71
- release 2 (by relup.sh)

* Fri Sep 06 2019 Marcin Krol <hawk@tld-linux.org> 2b3eb2d
- remove files we don't want to package

* Wed Aug 28 2019 Marcin Krol <hawk@tld-linux.org> e356d51
- dropped cfg_to_dot (its from examples subdir)
- dropped unstrip and its non-binary *.db files

* Wed Aug 28 2019 Marcin Krol <hawk@tld-linux.org> 676d1ad
- updated to 10.1.0

* Mon Apr 22 2019 Jan Rękorajski <baggins@pld-linux.org> 1f0ad28
- fix building with boost 1.69+
- rel 2

* Sun Nov 26 2017 Jakub Bogusz <qboosh@pld-linux.org> ece5262
- updated to 9.3.2

* Mon Apr 10 2017 Jakub Bogusz <qboosh@pld-linux.org> 770436b
- updated to 9.3.1
- updated libname patch
- added types patch (fixes unsigned long vs Offset/Address type mismatches)

* Sun Apr 09 2017 Jan Rękorajski <baggins@pld-linux.org> 995b957
- rebuild with boost 1.63.0
- release 2 (by relup.sh)

* Mon Aug 01 2016 Jakub Bogusz <qboosh@pld-linux.org> 91c3c39
- updated to 9.2.0
- updated libname patch

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> ef7c3a6
- icu-57.1 rebuild
- release 2 (by relup.sh)

* Tue Apr 05 2016 Jakub Bogusz <qboosh@pld-linux.org> b42727c
- updated to 9.1.0
- removed obsolete build-symlite patch

* Sat Nov 14 2015 Jan Rękorajski <baggins@pld-linux.org> 0094d0d
- release 2 (by relup.sh)

